<?php
/* Autor...:  */
/* Esquema.: ALM_TipoDocumento.xml */
/* Generado: 2020-08-18 04:21:24 */

/* Metodos de acceso a los campos de la tabla ALM_TipoDocumento */
abstract class BaseALM_TipoDocumentoBN
{
    /* Campos de la tabla */
    private $s_IdTipoDocumento;    // IdTipoDocumento: ( no definido )
    private $s_CodigoSunat;    // CodigoSunat: ( no definido )
    private $s_Descripcion;    // Descripcion: ( no definido )
    private $s_EsFiscalFlag;    // EsFiscalFlag: ( no definido )
    private $s_TransaccionSistemaFlag;    // TransaccionSistemaFlag: ( no definido )
    private $s_Estado;    // Estado: ( no definido )
    private $s_UsuarioCreacion;    // UsuarioCreacion: ( no definido )
    private $d_FechaModificacion;    // FechaModificacion: ( no definido )
    private $d_FechaCreacion;    // FechaCreacion: ( no definido )
    private $s_UsuarioModificacion;    // UsuarioModificacion: ( no definido )

    /* Establece el valor del campo IdTipoDocumento */
    public function setIdTipoDocumento( $s_IdTipoDocumento )
    {
        $this->s_IdTipoDocumento = $s_IdTipoDocumento;
    }

    /* Obtiene el valor del campo IdTipoDocumento */
    public function getIdTipoDocumento()
    {
        return $this->s_IdTipoDocumento;
    }

    /* Establece el valor del campo CodigoSunat */
    public function setCodigoSunat( $s_CodigoSunat )
    {
        $this->s_CodigoSunat = $s_CodigoSunat;
    }

    /* Obtiene el valor del campo CodigoSunat */
    public function getCodigoSunat()
    {
        return $this->s_CodigoSunat;
    }

    /* Establece el valor del campo Descripcion */
    public function setDescripcion( $s_Descripcion )
    {
        $this->s_Descripcion = $s_Descripcion;
    }

    /* Obtiene el valor del campo Descripcion */
    public function getDescripcion()
    {
        return $this->s_Descripcion;
    }

    /* Establece el valor del campo EsFiscalFlag */
    public function setEsFiscalFlag( $s_EsFiscalFlag )
    {
        $this->s_EsFiscalFlag = $s_EsFiscalFlag;
    }

    /* Obtiene el valor del campo EsFiscalFlag */
    public function getEsFiscalFlag()
    {
        return $this->s_EsFiscalFlag;
    }

    /* Establece el valor del campo TransaccionSistemaFlag */
    public function setTransaccionSistemaFlag( $s_TransaccionSistemaFlag )
    {
        $this->s_TransaccionSistemaFlag = $s_TransaccionSistemaFlag;
    }

    /* Obtiene el valor del campo TransaccionSistemaFlag */
    public function getTransaccionSistemaFlag()
    {
        return $this->s_TransaccionSistemaFlag;
    }

    /* Establece el valor del campo Estado */
    public function setEstado( $s_Estado )
    {
        $this->s_Estado = $s_Estado;
    }

    /* Obtiene el valor del campo Estado */
    public function getEstado()
    {
        return $this->s_Estado;
    }

    /* Establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion )
    {
        $this->s_UsuarioCreacion = $s_UsuarioCreacion;
    }

    /* Obtiene el valor del campo UsuarioCreacion */
    public function getUsuarioCreacion()
    {
        return $this->s_UsuarioCreacion;
    }

    /* Establece el valor del campo FechaModificacion */
    public function setFechaModificacion( $d_FechaModificacion )
    {
        $this->d_FechaModificacion = $d_FechaModificacion;
    }

    /* Obtiene el valor del campo FechaModificacion */
    public function getFechaModificacion()
    {
        return $this->d_FechaModificacion;
    }

    /* Establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion )
    {
        $this->d_FechaCreacion = $d_FechaCreacion;
    }

    /* Obtiene el valor del campo FechaCreacion */
    public function getFechaCreacion()
    {
        return $this->d_FechaCreacion;
    }

    /* Establece el valor del campo UsuarioModificacion */
    public function setUsuarioModificacion( $s_UsuarioModificacion )
    {
        $this->s_UsuarioModificacion = $s_UsuarioModificacion;
    }

    /* Obtiene el valor del campo UsuarioModificacion */
    public function getUsuarioModificacion()
    {
        return $this->s_UsuarioModificacion;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'IdTipoDocumento' => $this->getIdTipoDocumento(),
            'CodigoSunat' => $this->getCodigoSunat(),
            'Descripcion' => $this->getDescripcion(),
            'EsFiscalFlag' => $this->getEsFiscalFlag(),
            'TransaccionSistemaFlag' => $this->getTransaccionSistemaFlag(),
            'Estado' => $this->getEstado(),
            'UsuarioCreacion' => $this->getUsuarioCreacion(),
            'FechaModificacion' => $this->getFechaModificacion(),
            'FechaCreacion' => $this->getFechaCreacion(),
            'UsuarioModificacion' => $this->getUsuarioModificacion(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto ALM_TipoDocumentoBN desde un RecordSet */
    public static function retrieveByRs( $o_ALM_TipoDocumentoRs )
    {
        $o_ALM_TipoDocumentoBN = new ALM_TipoDocumentoBN();
        $o_ALM_TipoDocumentoBN->setIdTipoDocumento( $o_ALM_TipoDocumentoRs[ "IdTipoDocumento" ] );
        $o_ALM_TipoDocumentoBN->setCodigoSunat( $o_ALM_TipoDocumentoRs[ "CodigoSunat" ] );
        $o_ALM_TipoDocumentoBN->setDescripcion( $o_ALM_TipoDocumentoRs[ "Descripcion" ] );
        $o_ALM_TipoDocumentoBN->setEsFiscalFlag( $o_ALM_TipoDocumentoRs[ "EsFiscalFlag" ] );
        $o_ALM_TipoDocumentoBN->setTransaccionSistemaFlag( $o_ALM_TipoDocumentoRs[ "TransaccionSistemaFlag" ] );
        $o_ALM_TipoDocumentoBN->setEstado( $o_ALM_TipoDocumentoRs[ "Estado" ] );
        $o_ALM_TipoDocumentoBN->setUsuarioCreacion( $o_ALM_TipoDocumentoRs[ "UsuarioCreacion" ] );
        $o_ALM_TipoDocumentoBN->setFechaModificacion( utilTimestamp::getTimestamp( $o_ALM_TipoDocumentoRs[ "FechaModificacion" ], "Y-m-d H:i:s" ) );
        $o_ALM_TipoDocumentoBN->setFechaCreacion( utilTimestamp::getTimestamp( $o_ALM_TipoDocumentoRs[ "FechaCreacion" ], "Y-m-d H:i:s" ) );
        $o_ALM_TipoDocumentoBN->setUsuarioModificacion( $o_ALM_TipoDocumentoRs[ "UsuarioModificacion" ] );
        return $o_ALM_TipoDocumentoBN;
    }
}
?>